#
# spec file for package deepin-gir-generator
#
# Copyright (c) 2019 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

%define _name go-gir-generator

Name:           deepin-gir-generator
Version:        2.1.0
Release:        1.13
Summary:        Go-gir-generator imeplement static golang bindings for GObject
License:        MIT
Group:          Development/Languages/Golang
Url:            https://github.com/linuxdeepin/go-gir-generator
Source:         https://github.com/linuxdeepin/%{_name}/archive/%{version}/%{_name}-%{version}.tar.gz
Source99:       %{name}-rpmlintrc
BuildRequires:  golang-packaging
BuildRequires:  pkgconfig(gobject-introspection-1.0)
BuildRequires:  pkgconfig(gudev-1.0)
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gobject-2.0)
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  pkgconfig(gdk-2.0)
BuildRequires:  pkgconfig(gdk-3.0)
BuildRequires:  pkgconfig(gudev-1.0)
BuildRequires:  fdupes
Provides:       %{_name}
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Go-gir-generator imeplement static golang bindings for GObject.

There has many go bindings for GObject/Gtk libraries, but almost all of them 
are written by hand. It's bored and error-prone when the binding C libaray 
changed.

Go-gir-geneator's object is like python-gobject's that binding the newest 
library without need change binding codes.

Currently it only official support Gobject-2.0, Glib-2.0, Gio-2.0. Because 
generate the gdkpixbuf binding hasn't completed, so Gdk/Gtk were also in blocking.


%package -n golang-github-linuxdeepin-go-gir-generator
Summary:        Additional mobile libraries
Group:          Development/Languages/Golang
AutoReqProv:    Off
BuildRequires:  golang-packaging
BuildRequires:  pkgconfig(gobject-introspection-1.0)
BuildRequires:  pkgconfig(gudev-1.0)
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gobject-2.0)
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  pkgconfig(gdk-2.0)
BuildRequires:  pkgconfig(gdk-3.0)
BuildRequires:  pkgconfig(gudev-1.0)
Requires:       pkgconfig(gobject-introspection-1.0)
Requires:       pkgconfig(gudev-1.0)
Requires:       pkgconfig(glib-2.0)
Requires:       pkgconfig(gobject-2.0)
Requires:       pkgconfig(gio-2.0)
Requires:       pkgconfig(gdk-2.0)
Requires:       pkgconfig(gdk-3.0)
Requires:       pkgconfig(gudev-1.0)
Provides:       golang(github.com/linuxdeepin/go-gir/glib-2.0)
Provides:       golang(github.com/linuxdeepin/go-gir/gio-2.0)
Provides:       golang(github.com/linuxdeepin/go-gir/gobject-2.0)
Provides:       golang(github.com/linuxdeepin/go-gir/gudev-1.0)
BuildArch:      noarch

%{go_exclusivearch}

%description -n golang-github-linuxdeepin-go-gir-generator
Go-gir-generator imeplement static golang bindings for GObject.

There has many go bindings for GObject/Gtk libraries, but almost all of them 
are written by hand. It's bored and error-prone when the binding C libaray 
changed.

Go-gir-geneator's object is like python-gobject's that binding the newest 
library without need change binding codes.

Currently it only official support Gobject-2.0, Glib-2.0, Gio-2.0. Because 
generate the gdkpixbuf binding hasn't completed, so Gdk/Gtk were also in blocking.

%prep
%autosetup -p1 -n %{_name}-%{version}

# fix go source path
%if 0%{?suse_version} >= 1330
sed -i 's|gocode|go/%{go_api_ver}/contrib|' Makefile
%else
sed -i 's|gocode|go/contrib|' Makefile
%endif

%build
export GO111MODULE=off
make %{?_smp_mflags}

%install
%make_install

%fdupes %{buildroot}

%files
%defattr(-,root,root,-)
%doc README.md documentation/WhyWaf.txt documentation/Design.txt
%license LICENSE
%{_bindir}/gir-generator

%files -n golang-github-linuxdeepin-go-gir-generator
%defattr(-,root,root,-)
%{go_contribsrcdir}/*

%changelog
* Sat Apr  2 2022 Hillwood Yang <hillwood@opensuse.org>
- Update version to 2.1.0
  * Change pkg.deepin.io to github.com
  * Update readme
* Wed Feb 23 2022 Hillwood Yang <hillwood@opensuse.org>
- Use last stable version of go to build
* Fri Feb 18 2022 Hillwood Yang <hillwood@opensuse.org>
- Update version to 2.0.8
  * add struct SettingsSchema
  * fix compatibility with glib 2.63+
- Drop support-glib2_36-and-higher.patch
* Fri Jan 28 2022 Hillwood Yang <hillwood@opensuse.org>
- Keep golang version on 1.15 on Leap15.4+
* Fri May 21 2021 Hillwood Yang <hillwood@opensuse.org>
- Keep golang version on 1.15 on Tumbleweed, the project does not support
  golang 1.16+
* Mon Jul 29 2019 Hillwood Yang <hillwood@opensuse.org>
- Update version to 2.0.2
  * Fix memory test failed on arm64 arch
  * Feat: memory test comparing growth
  * Fix path in Makefile, drop Fix-path.patch
  * Chore: improve english
- Add support-glib2_36-and-higher.patch, fix compatibility with glib 2.63+
* Wed Apr 10 2019 Hillwood Yang <hillwood@opensuse.org>
- Update version to 2.0.0
  * chore: put code into pkg.deepin.io dir
  * fix: build issues with new glib2/gobject-introspection
- Add Fix-path.patch, fix path in makefile
- Remove SettingsBackendLike.patch, merged.
* Sat Mar  9 2019 Hillwood Yang <hillwood@opensuse.org>
- Set two Provides tags for golang-dbus-factory
  * Set golang(pkg.deepin.io/gir/glib-2.0) as Provides tag
  * Set golang(pkg.deepin.io/gir/gio-2.0) as Provides tag
* Tue Feb 26 2019 Aaron Stern <ukbeast89@ptotonmail.com>
- update to 1.2.0
  * Compile with sw arch no longer needs to use gccgo
  * Fix dde-api build error with gobject-introspection 1.58+
  * Fix `sw_64` no export `USE_GCCGO=1`
  * Fix `sw_64` gccgo720 build failed
* Wed Nov  8 2017 hillwood@opensuse.org
- update to 1.0.2
  * Fix gccgo compile failed
  * Fix map concurrent crashed
  * Fix Install missing Typelib file for GUdev
  * Support g_bytes_get_data()
- Add SettingsBackendLike.patch.
  * Add SettingsBackend.
* Sun Feb 26 2017 hillwood@opensuse.org
- Initial package.
